﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Drawing.Drawing2D;

namespace howto_draw_pie_slices
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // Draw pie slices.
        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            e.Graphics.SmoothingMode = SmoothingMode.AntiAlias;

            const int margin = 10;
            const int width = 100;
            Graphics gr = e.Graphics;
            Pen outline_pen = Pens.Red;
            Brush fill_brush = Brushes.LightGreen;

            using (Pen ellipse_pen = new Pen(Color.Blue))
            {
                ellipse_pen.DashPattern = new float[] { 5, 5 };

                // Northeast wedge.
                Rectangle rect = new Rectangle(margin + 30, 10, width, width);
                gr.DrawEllipse(ellipse_pen, rect);
                gr.FillPie(fill_brush, rect, 300, 30);
                gr.DrawPie(outline_pen, rect, 300, 30);

                // Everything else.
                rect.X += width + margin;
                gr.DrawEllipse(ellipse_pen, rect);
                gr.FillPie(fill_brush, rect, 300, -330);
                gr.DrawPie(outline_pen, rect, 300, -330);

                // East wedge.
                rect.Y += width + margin;
                rect.X = margin + 30;
                gr.DrawEllipse(ellipse_pen, rect);
                gr.FillPie(fill_brush, rect, 315, 90);
                gr.DrawPie(outline_pen, rect, 315, 90);

                // Everything else.
                rect.X += width + margin;
                gr.DrawEllipse(ellipse_pen, rect);
                gr.FillPie(fill_brush, rect, 315, -270);
                gr.DrawPie(outline_pen, rect, 315, -270);

                // Northwest quadrant.
                rect.Y += width + margin;
                rect.X = margin + 30;
                gr.DrawEllipse(ellipse_pen, rect);
                gr.FillPie(fill_brush, rect, 180, 90);
                gr.DrawPie(outline_pen, rect, 180, 90);

                // Everything else.
                rect.X += width + margin;
                gr.DrawEllipse(ellipse_pen, rect);
                gr.FillPie(fill_brush, rect, 180, -270);
                gr.DrawPie(outline_pen, rect, 180, -270);
            }
        }
    }
}
